#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;
#ifdef LOG
FILE *flog;
#endif

#define MAX_QUERIES 75

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG
void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);}
#endif

char str[20];
char mask[50];
int q;

bool Check(char *str, char *mask) {
	int i, j, o;
	int l1, l2;
	bool d[50][50];
	ZERO(d);
	l1 = (int)strlen(str);
	l2 = (int)strlen(mask);
	d[0][0] = 1;
	fi(0, l1) {
		fj(1, l2) {
			if (i != 0 && str[i - 1] == mask[j - 1] && d[i - 1][j - 1]) {
				d[i][j] = 1;
			}
			if (mask[j - 1] == '*') {
				fo(0, i) {
					if (d[o][j - 1]) {
						d[i][j] = 1;
						break;
					}
				}
			}
		}
	}
	return d[l1][l2];
}

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	char num[10];
	int i;
	int l;
#ifdef LOG
	flog = fopen("log.txt", "w");
#endif

	fscanf(fin, "%s", str);

#ifdef LOG
	Log("Unknown string: " + (string)str + "\n");
#endif

	q = 0;
	while (1) {
		q++;
		switch (scanf("%25s", mask)) {
			case 1:
				break;
			case -1:
				id("Unexpected EOF");
				break;
			default:
				pe("Wrong output format");
				break;
		}
		if (strlen(mask) > 21) {
			//printf("Exit\n");
			//fflush(stdout);
			wa("The length of mask is too long");
		}

#ifdef LOG
		Log((string)mask + ":");
#endif

		l = (int)strlen(mask);
		fi(0, l - 1) {
			if (!(mask[i] >= 'a' && mask[i] <= 'z' || mask[i] == '*')) {
				//printf("Exit\n");
				//fflush(stdout);
				pe("Found unexpected symbol");
			}
		}

		if (strcmp(str, mask) == 0) {
			printf("Exit\n");
			fflush(stdout);
			sprintf(num, "%d", q);
			ok(num + (string)" queries");
		}

		if (q >= MAX_QUERIES) {
			//printf("Exit\n");
			//fflush(stdout);
			ql("Too many queries");
		}

		if (Check(str, mask)) {
#ifdef LOG
			Log("Yes");
#endif
			printf("Yes\n");
		} else {
			printf("No\n");
#ifdef LOG
			Log("No");
#endif
		}
		fflush(stdout);
	}
	return 0;
}
