#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;

#ifdef LOG
FILE *flog;
#endif

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAX 15

#define MAX_QUERIES 10000

int n, m;
int x, y;

char matr[MAX][MAX];
int color[MAX][MAX];

char matr2[MAX][MAX];
int color2[MAX][MAX];

char com[10];

int q;

#ifdef LOG
void Print() {
	int i, j;
	fj(0, m - 1) {
		fi(0, n - 1) {
			if (i == x && j == y) {
				fprintf(flog, "P");
			} else {
				fprintf(flog, "%c", matr[j][i]);
			}
		}
		fprintf(flog, "\n");
	}
	fprintf(flog, "\n");
	fflush(flog);
}
#endif

int Count() {
	int i, j;
	int res;
	res = 0;
	fi(0, n - 1) {
		if (matr[y][i] == '*') res++;
	}
	fj(0, m - 1) {
		if (matr[j][x] == '*') res++;
	}
	return res;
}

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	int i, j;
	int flag;
	char num[20];
#ifdef LOG
	flog = fopen("log.txt", "w");
#endif

	fscanf(fin, "%d %d", &m, &n);
	fj(0, m - 1) {
		fscanf(fin, "%s", matr[j]);
	}


	x = 0;
	y = 0;

#ifdef LOG
	Print();
#endif

	while (1) {

		printf("%d\n", Count());
#ifdef LOG
		fprintf(flog, "%d\n", Count());
#endif
		fflush(stdout);
		q++;
		switch (scanf("%2s", com)) {
			case 1:
				break;
			case -1:
				id("Unexpected EOF");
				break;
			default:
				pe("Wrong output format");
				break;
		}
		if (strcmp(com, "u") == 0) {
			y = (y - 1 + m) % m;
		} else if (strcmp(com, "d") == 0) {
			y = (y + 1) % m;
		} else if (strcmp(com, "l") == 0) {
			x = (x - 1 + n) % n;
		} else if (strcmp(com, "r") == 0) {
			x = (x + 1) % n;
		} else if (strcmp(com, "U") == 0) {
			y = (y - 1 + m) % m;

			COPY(matr2, matr);
			COPY(color2, color);
			fj(0, m - 1) {
				matr2[j][x] = matr[(j + 1) % m][x];
				color2[j][x] = color[(j + 1) % m][x];
			}
			COPY(matr, matr2);
			COPY(color, color2);

		} else if (strcmp(com, "D") == 0) {
			y = (y + 1) % m;

			COPY(matr2, matr);
			COPY(color2, color);
			fj(0, m - 1) {
				matr2[j][x] = matr[(j - 1 + m) % m][x];
				color2[j][x] = color[(j - 1 + m) % m][x];
			}
			COPY(matr, matr2);
			COPY(color, color2);

		} else if (strcmp(com, "L") == 0) {
			x = (x - 1 + n) % n;
			
			COPY(matr2, matr);
			COPY(color2, color);
			fi(0, n - 1) {
				matr2[y][i] = matr[y][(i + 1) % n];
				color2[y][i] = color[y][(i + 1) % n];
			}
			COPY(matr, matr2);
			COPY(color, color2);

		} else if (strcmp(com, "R") == 0) {
			x = (x + 1) % n;

			COPY(matr2, matr);
			COPY(color2, color);
			fi(0, n - 1) {
				matr2[y][i] = matr[y][(i - 1 + n) % n];
				color2[y][i] = color[y][(i - 1 + n) % n];
			}
			COPY(matr, matr2);
			COPY(color, color2);
		} else {
			//printf("-1\n");
			//fflush(stdout);
			pe("Unknown command");
		}		

		if (matr[y][x] == '*') {
			//printf("-1\n");
			//fflush(stdout);
			wa("Participant has moved to cell with mine");
		}

#ifdef LOG
		Print();
#endif

		color[y][x] = 1;
		flag = 0;
		fj(0, m - 1) {
			fi(0, n - 1) {
				if (matr[j][i] == '.' && color[j][i] == 0) {
					flag = 1;
				}
			}
		}
		if (!flag) {
			printf("-1\n");
			fflush(stdout);
			sprintf(num, "%d", q);
			ok((string)num + " queries");
		}

		if (q >= MAX_QUERIES) {
			//printf("-1\n");
			//fflush(stdout);
			wa("Too many queries");
		}
		
	}

	return 0;
}
