//////////////////////////gen.h//////////////////////////

#include "testlib.h"
#include <iostream>

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

using namespace std;

int gen_test = 0;
bool first;

void Next() {
	gen_test++;
    startTest(gen_test);
    first = true;
}

/*void Skip(int x) {
	gen_test += x;
}*/

void Line() {
    cout << endl;
    first = true;
}

void NumberNS(int a) {
	cout << a;
}

void NumberNS(int64 a) {
    cout << a;
}

void Number(int a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	cout << a;
}

void Number(int a, int b) {
	Number(a); Number(b);
}

void Number(int a, int b, int c) {
	Number(a); Number(b); Number(c);
}

void Number(int a, int b, int c, int d) {
	Number(a); Number(b); Number(c); Number(d);
}

void Number(int64 a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	cout << a;
}

void Number(int64 a, int64 b) {
	Number(a); Number(b);
}

void Number(int64 a, int64 b, int64 c) {
	Number(a); Number(b); Number(c);
}

void Number(int64 a, int64 b, int64 c, int64 d) {
	Number(a); Number(b); Number(c); Number(d);
}

void String(const char *s) {
    cout << string(s);
}

void Char(char c) {
    cout << c;
}

void Space() {
    first = false;
	cout << " ";
}

int Random(int a, int b) {
	return rnd.next(a, b);
}

int64 Random(int64 a, int64 b) {
	return rnd.next(a, b);
}

/////////////////////////////////////////////////////////

void Gen(int n, int m, int p) {
	int i, j;
	int x, y;
	Next();
	Number(m, n); Line();

	do {
		x = Random(1, n);
		y = Random(1, m);
	} while (x == 1 && y == 1);

	fj(1, m) {
		fi(1, n) {
			if (j == 1 && i == 1 || i == x && j == y) {
				Char('.');
			} else {
				if (Random(0, 99) < p) {
					Char('*');
				} else {
					Char('.');
				}
			}
		}
		Line();
	}
}

void Sample() {
	Next();
	Number(4, 3); Line();
	String(".**"); Line();
	String("*.*"); Line();
	String("*.*"); Line();
	String("**."); Line();
}

void Gen2(int n, int m) {
	int i, j;
	int x, y;
	Next();
	Number(m, n); Line();

	do {
		x = Random(1, n);
		y = Random(1, m);
	} while (x == 1 && y == 1);

	fj(1, m) {
		fi(1, n) {
			if (i == x && j == y) {
				Char('*');
			} else {
				Char('.');
			}
		}
		Line();
	}
}

int main(int argc, char* argv[]) {
	int i;
    registerGen(argc, argv);

	Sample();
	fi(1, 6) {
		Gen(Random(2, 4), Random(2, 4), Random(10, 30));
	}

	Gen2(2, 2);
	Gen2(2, 4);
	Gen2(4, 2);
	Gen2(3, 3);

	fi(1, 6) {
		Gen(Random(3, 6), Random(3, 6), Random(10, 40));
	}
	fi(1, 12) {
		Gen(Random(5, 9), Random(5, 9), Random(10, 80));
	}

	fi(1, 8) {
		Gen2(Random(5, 9), Random(5, 9));
	}

	Gen(2, 6, 50);
	
	Gen(2, 10, 10);
	Gen(2, 10, 30);
	Gen(2, 10, 60);
	Gen(2, 10, 80);
	Gen(2, 10, 100);

	Gen(10, 2, 10);
	Gen(10, 2, 30);
	Gen(10, 2, 60);
	Gen(10, 2, 80);
	Gen(10, 2, 100);

	Gen(3, 10, 10);
	Gen(3, 10, 30);
	Gen(3, 10, 60);
	Gen(3, 10, 80);
	Gen(3, 10, 100);

	Gen(10, 3, 10);
	Gen(10, 3, 30);
	Gen(10, 3, 60);
	Gen(10, 3, 80);
	Gen(10, 3, 100);

	Gen(2, 4, 0);
	Gen(5, 5, 0);
	Gen(4, 7, 0);
	Gen(8, 4, 0);
	Gen(10, 10, 0);

	fi(1, 4) {
		Gen2(10, 10);
	}

	fi(1, 2) {
		Gen2(Random(5, 9), 10);
		Gen2(10, Random(5, 9));
	}

	fi(1, 7) {
		Gen(10, 10, Random(10, 95));
	}
	Gen(10, 10, 100);
	fi(1, 5) {
		Gen(Random(2, 9), 10, Random(10, 95));
		Gen(10, Random(2, 9), Random(10, 95));
	}
    return 0;
}
