#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

#define NUMBER_OF_TESTS 4000

FILE *fin;

#ifdef LOG

FILE *flog;
FILE *flog2;

#endif

#define P1 70
#define P2 100

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAX 10

int n, k;

int f[MAX];

int q[MAX];
int nec[MAX];

double p[MAX];

int victories;

void Game() {
	vector <int> v;
	int i, j;
	int x;
	int s;
	int score1, score2;
	ZERO(f);
	ZERO(p);
	score1 = 0;
	score2 = 0;
	fi(1, k) {
		do {
			x = rnd.next(1, n);
		} while (f[x]);
		f[x] = 1;
	}

#ifdef LOG
	fi(1, n) {
		if (!f[i]) {
			fprintf(flog, ".");
		} else {
			fprintf(flog, "*");
		}
	}
	fprintf(flog, "\n");
	fflush(flog);
#endif

	fi(1, n) {
		if (f[i]) {
			p[i] = (rnd.next(0, 1000000) / 1000000.) * (P2 - P1) + P1;
		}
	}

	printf("%d\n", n);
	fflush(stdout);

	fi(1, 5) {
		printf("%d\n", q[i]);
		fflush(stdout);
		v.clear();
		fj(1, q[i]) {
			switch (scanf("%d", &x)) {
				case 1:
					break;
				case -1:
					id("Unexpected EOF");
					break;
				default:
					pe("Wrong output format");
					break;
			}
			if (x < 1 || x > n) {
				//printf("-1\n");
				//fflush(stdout);
				pe("Player number is out of range");
			}
			v.pb(x);
		}

		sort(v.begin(), v.end());

		s = 0;
		fj(0, SIZE(v) - 1) {
			if (j > 0 && v[j] == v[j - 1]) {
				//printf("-1\n");
				//fflush(stdout);
				pe("List contains two equal numbers");
			}
			if (f[v[j]]) {
				if (score2 == 2 || (rnd.next(0, 1000000) / 1000000.) * 100 <= p[v[j]]) {
					s++;
				}
			}
		}
		
		if (s >= nec[i]) {
			score2++;
		} else {
			score1++;
		}

#ifdef LOG
		int o;
		j = 0;
		fo(1, n) {
			if (j < SIZE(v) && v[j] == o) {
				fprintf(flog, "?");
				j++;
			} else {
				fprintf(flog, ".");
			}
		}
#endif

		if (score1 == 3) {
#ifdef LOG
			fprintf(flog, "\nWIN\n");
			fflush(flog);
#endif
			victories++;
			printf("WIN\n");
			fflush(stdout);
			return;
		}

		if (score2 == 3) {
#ifdef LOG
			fprintf(flog, "\nLOSE\n");
			fflush(flog);
#endif
			printf("LOSE\n");
			fflush(stdout);
			return;
		}

#ifdef LOG
		fprintf(flog, " (%d)\n", s);
		fflush(flog);
#endif
		printf("%d\n", s);
		fflush(stdout);

	}
}

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	double winrate;
	int i;
	char str[100];
#ifdef LOG
	flog = fopen("log.txt", "w");
	flog2 = fopen("log2.txt", "w");
#endif
	
	fscanf(fin, "%d", &n);

	if (n == 5) {
		k = 2;
		q[1] = 2;
		nec[1] = 1;
		q[2] = 3;
		nec[2] = 1;
		q[3] = 2;
		nec[3] = 1;
		q[4] = 3;
		nec[4] = 1;
		q[5] = 3;
		nec[5] = 1;
	}

	if (n == 6) {
		k = 2;
		q[1] = 2;
		nec[1] = 1;
		q[2] = 3;
		nec[2] = 1;
		q[3] = 4;
		nec[3] = 1;
		q[4] = 3;
		nec[4] = 1;
		q[5] = 4;
		nec[5] = 1;
	}

	if (n == 7) {
		k = 3;
		q[1] = 2;
		nec[1] = 1;
		q[2] = 3;
		nec[2] = 1;
		q[3] = 3;
		nec[3] = 1;
		q[4] = 4;
		nec[4] = 2;
		q[5] = 4;
		nec[5] = 1;
	}

	if (n == 8) {
		k = 3;
		q[1] = 3;
		nec[1] = 1;
		q[2] = 4;
		nec[2] = 1;
		q[3] = 4;
		nec[3] = 2;
		q[4] = 5;
		nec[4] = 2;
		q[5] = 5;
		nec[5] = 1;
	}

	if (n == 9) {
		k = 3;
		q[1] = 3;
		nec[1] = 1;
		q[2] = 4;
		nec[2] = 1;
		q[3] = 4;
		nec[3] = 1;
		q[4] = 5;
		nec[4] = 2;
		q[5] = 5;
		nec[5] = 1;
	}

	victories = 0;

	fi(1, NUMBER_OF_TESTS) {
		Game();
	}

#ifdef LOG
	fprintf(flog, "-1\n");
	fflush(flog);
#endif

	printf("-1\n");
	fflush(stdout);

	winrate = victories * 100. / NUMBER_OF_TESTS;

	sprintf(str, "Winrate: %.4lf%%", winrate);

	if (winrate >= 49) {
		ok(str);
	} else {
		wa(str);
	}

	return 0;
}
