#pragma comment(linker, "/STACK:64000000")

#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;

#ifdef LOG
FILE *flog, *flog2;
#endif

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAX 120

int num;
int x, y;
int last;
char matr[MAX][MAX];

int n = 80;

int dx[] = {-1,0,1,0};
int dy[] = {0,-1,0,1};

int rotation;

int q;

bool Field(int x, int y) {
	if (x < 0 || x > n) return false;
	if (y < 0 || y > n) return false;
	return true;
}

bool Border(int x, int y) {
	if (x == 0 || x == n) return true;
	if (y == 0 || y == n) return true;
	return false;
}

void Print() {
#ifdef LOG
	int i, j;
	fj(0, n) {
		fi(0, n) {
			if (i == x && j == y) {
				fprintf(flog, "R");
			} else {
				fprintf(flog, "%c", matr[j][i]);
			}
		}
		fprintf(flog, "\n");
	}
	fprintf(flog, "\n");
	fflush(flog);
#endif
}

void Read() {
	int cx, cy;
	int cx2, cy2;
	q++;
	cx = -1;
	cy = -1;
	
	switch (scanf("%d %d", &cy, &cx)) {
		case 2:
			break;
		case -1:
			id("Unexpected EOF");
			break;
		default:
			pe("Wrong output format");
			break;
	}
	if (cx < 0 || cx > n || cy < 0 || cy > n) {
		//printf("E\n");
		//fflush(stdout);
		pe("Coordinates are out of range");
	}

	switch (rotation) {
		case 0:
			cx2 = cx;
			cy2 = cy;
			break;
		case 1:
			cx2 = cy;
			cy2 = n - cx;
			break;
		case 2:
			cx2 = n - cx;
			cy2 = n - cy;
			break;
		case 3:
			cx2 = n - cy;
			cy2 = cx;
			break;		
	}

	if (cx2 == x && cy2 == y) {
		//printf("E\n");
		//fflush(stdout);
		pe("Attempt to burn cell with robot");
	}
	if (matr[cy2][cx2] == '#') {
		//printf("E\n");
		//fflush(stdout);
		pe("Attempt to burn cell which is already burned");
	}

	matr[cy2][cx2] = '#';
	
	Print();
}

void Exit() {
	char str[100];
	printf("E\n");
	fflush(stdout);
	sprintf(str, "%d moves", q);
	ok(str);
}

int sqr(int x) {
	return x * x;
}

int Dist(int x1, int y1, int x2, int y2) {
	return abs(x1 - x2) + abs(y1 - y2);
}

void Move(int dir, int len) {
	int i;

	fi(1, len) {

		x += dx[dir];
		y += dy[dir];

		if (matr[y][x] == '#') {
			Exit();
		}

		if (Border(x, y)) {
			//printf("E\n");
			//fflush(stdout);
			wa("The robot has left the field");
		}

	}

	dir = (dir + rotation) % 4;
	switch (dir) {
		case 0:
			printf("L ");
#ifdef LOG
			fprintf(flog2, "L ");
#endif
			break;
		case 1:
			printf("U ");
#ifdef LOG
			fprintf(flog2, "U ");
#endif
			break;
		case 2:
			printf("R ");
#ifdef LOG
			fprintf(flog2, "R ");
#endif
			break;
		case 3:
			printf("D ");
#ifdef LOG
			fprintf(flog2, "D ");
#endif
			break;
	}
	printf("%d\n", len);
	fflush(stdout);
#ifdef LOG
	fprintf(flog2, "%d\n", len);
	fflush(flog2);
#endif	

}

int color[MAX][MAX];
int d[MAX][MAX][MAX];
pair< pair <int, int>, int> p[MAX][MAX][165];

bool bfs(bool final[MAX][MAX]) {
	queue <pair <pair<int, int>, int> > qu;
	stack <pair <pair<int, int>, int> > st;
	int x0, y0, last0;
	int x2, y2, last2;
	int i, j;
	int flag;

	ZERO(color);
	ZERO(p);

	qu.push(mp(mp(x, y), last));

	color[y][x] = 1;
	final[y][x] = 0;

	flag = 0;

	while (!qu.empty()) {
		x0 = qu.front().first.first;
		y0 = qu.front().first.second;
		last0 = qu.front().second;
		qu.pop();
		if (final[y0][x0]) {
			flag = 1;
			break;
		}
		fi(0, 3) {
			x2 = x0;
			y2 = y0;			

			if (i == last0 % 10) {
				fj(1, min(12, last0 / 10 + 1)) {
					x2 += dx[i];
					y2 += dy[i];
					last2 = j * 10 + i;
					if (!Field(x2, y2)) break;
					if (matr[y2][x2] == '#') break;
					if (color[y2][x2]) break;
					color[y2][x2] = 1;
					p[y2][x2][last2] = mp(mp(x0, y0), last0);
					st.push(mp(mp(x2, y2), last2));
				}
				while (!st.empty()) {
					qu.push(st.top());
					st.pop();
				}
			} else {
				x2 += dx[i];
				y2 += dy[i];
				last2 = 10 + i;
				if (Field(x2, y2) && !color[y2][x2] && matr[y2][x2] != '#') {
					color[y2][x2] = 1;
					qu.push(mp(mp(x2, y2), last2));
					p[y2][x2][last2] = mp(mp(x0, y0), last0);
				}
			}
		}
	}

	if (!flag) return false;
	while (1) {
		x2 = p[y0][x0][last0].first.first;
		y2 = p[y0][x0][last0].first.second;
		last2 = p[y0][x0][last0].second;
		if (x2 == x && y2 == y && last2 == last) break;
		x0 = x2;
		y0 = y2;
		last0 = last2;
	}

	last = last0;

	Move(last0 % 10, last0 / 10);
	
	return true;
}

bool Dijkstra(int value[MAX][MAX], bool final[MAX][MAX]) {
	set <pair<int, pair < pair<int, int>, int> > > t;
	int x0, y0, last0;
	int x2, y2, last2;
	int i, j, o;
	int flag;
	int v;
	
	ZERO(color);
	ZERO(p);

	fj(0, n) {
		fi(0, n) {
			fo(0, 160) {
				d[j][i][o] = 1000000000;
			}
		}
	}

	d[y][x][last] = 0;

	t.insert(mp(0, mp(mp(x, y), last)));
	
	flag = 0;

	while (!t.empty()) {
		x0 = t.begin()->second.first.first;
		y0 = t.begin()->second.first.second;
		last0 = t.begin()->second.second;
		t.erase(t.begin());

		if (color[y0][x0]) continue;

		color[y0][x0] = 1;

		if (final[y0][x0]) {
			flag = 1;
			break;
		}
		fi(0, 3) {
			x2 = x0;
			y2 = y0;			

			if (i == last0 % 10) {
				v = 0;
				fj(1, min(12, last0 / 10 + 1)) {
					x2 += dx[i];
					y2 += dy[i];
					last2 = j * 10 + i;

					v = max(v, value[y2][x2]);

					if (!Field(x2, y2)) break;
					if (matr[y2][x2] == '#') break;
					
					if (d[y0][x0][last0] + v < d[y2][x2][last2]) {
						d[y2][x2][last2] = d[y0][x0][last0] + v;
						p[y2][x2][last2] = mp(mp(x0, y0), last0);
						t.insert(mp(d[y2][x2][last2], mp(mp(x2, y2), last2)));
					}					
					
				}
			} else {
				x2 += dx[i];
				y2 += dy[i];
				last2 = 10 + i;
				if (Field(x2, y2) && matr[y2][x2] != '#') {
					if (d[y0][x0][last0] + value[y2][x2] < d[y2][x2][last2]) {
						d[y2][x2][last2] = d[y0][x0][last0] + value[y2][x2];
						p[y2][x2][last2] = mp(mp(x0, y0), last0);
						t.insert(mp(d[y2][x2][last2], mp(mp(x2, y2), last2)));
					}	
				}
			}
		}
	}

	if (!flag) return false;
	while (1) {
		x2 = p[y0][x0][last0].first.first;
		y2 = p[y0][x0][last0].first.second;
		last2 = p[y0][x0][last0].second;
		if (x2 == x && y2 == y && last2 == last) break;
		x0 = x2;
		y0 = y2;
		last0 = last2;
	}

	last = last0;

	Move(last0 % 10, last0 / 10);
	
	return true;
}

bool Neighbour4(int x, int y) {
	int x2, y2;
	int i;
	fi(0, 3) {
		x2 = x + dx[i];
		y2 = y + dy[i];
		if (!Field(x2, y2)) continue;
		if (matr[y2][x2] == '#') return true;
	}
	return false;
}

bool Neighbour8(int x, int y) {
	int x2, y2;
	int i, j;
	fi(-1, 1) {
		fj(-1, 1) {
			if (i == 0 && j == 0) continue;
			x2 = x + i;
			y2 = y + j;
			if (!Field(x2, y2)) continue;
			if (matr[y2][x2] == '#') return true;
		}
	}
	return false;
}


void Strategy1() {
	int i, j;
	bool final[MAX][MAX];
	ZERO(final);
	fj(0, n) {
		fi(0, n) {
			if (Border(i, j)) {
				final[j][i] = 1;
			}
		}
	}
	while (1) {

		if (!bfs(final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy2() {
	int i, j;
	int value[MAX][MAX];
	bool final[MAX][MAX];
	ZERO(final);
	fj(0, n) {
		fi(0, n) {
			if (Border(i, j)) {
				final[j][i] = 1;
			}
		}
	}
	while (1) {

		ZERO(value);

		fj(1, n - 1) {
			fi(1, n - 1) {
				if (Neighbour8(i, j)) {
					value[j][i] = 100;
				} else {
					value[j][i] = 1;
				}
			}
		}

		if (!Dijkstra(value, final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy3() {
	int i, j;
	int value[MAX][MAX];
	bool final[MAX][MAX];
	ZERO(final);
	fj(0, n) {
		fi(0, n) {
			if (Border(i, j)) {
				final[j][i] = 1;
			}
		}
	}
	while (1) {

		ZERO(value);

		fj(1, n - 1) {
			fi(1, n - 1) {
				if (Neighbour4(i, j)) {
					value[j][i] = 100;
				} else {
					value[j][i] = 1;
				}
			}
		}

		if (!Dijkstra(value, final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy4() {
	int i, j;
	bool final[MAX][MAX];	
	
	while (1) {

		ZERO(final);

		if (q <= 8) {
			final[35][35] = 1;
		} else if (q <= 12) {
			final[32][32] = 1;
		} else if (q <= 20) {
			final[26][26] = 1;
		} else if (q <= 28) {
			final[20][20] = 1;
		} else if (q <= 35) {
			final[14][14] = 1;
		} else if (q <= 45) {
			final[8][8] = 1;
		} else {
			fi(0, 25) {
				final[i][0] = 1;
				final[0][i] = 1;
			}
		}

		fdj(n, 1) {
			fdi(n, 1) {
				if (final[j][i] && (matr[j][i] == '#' || i == x && j == y)) {
					final[j][i] = 0;
					final[j - 1][i - 1] = 1;
				}
			}
		}

		if (!bfs(final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy5() {
	int i, j;
	int i2, j2;
	int value[MAX][MAX];
	bool final[MAX][MAX];
	ZERO(final);
	fj(0, n) {
		fi(0, n) {
			if (Border(i, j)) {
				final[j][i] = 1;
			}
		}
	}
	while (1) {

		ZERO(value);

		fj(1, n - 1) {
			fi(1, n - 1) {
				value[j][i] = 1;
				if (matr[j][i] == '.') {
					for (j2 = max(0, j - 3); j2 <= min(n, j + 3); j2++) {
						for (i2 = max(0, i - 3); i2 <= min(n, i + 3); i2++) {
							if (matr[j2][i2] == '#') {
								value[j][i] += 18 - sqr(i - i2) + sqr(j - j2);
							}
						}
					}
				}
			}
		}

		if (!Dijkstra(value, final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy6() {
	int j;
	bool final[MAX][MAX];
	
	while (1) {

		ZERO(final);

		if (q <= 30) {
			fj(0, n) {
				final[j][0] = 1;
			}
		} else {
			fj(0, n) {
				final[j][n] = 1;
			}
		}

		if (!bfs(final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy7() {
	int i, j, o;
	bool final[MAX][MAX];
	int value[MAX][MAX];
	
	while (1) {

		ZERO(final);

		if (q <= 25) {
			fj(0, n) {
				final[j][0] = 1;
			}
		} else {
			fj(0, n) {
				final[j][n] = 1;
			}
		}

		ZERO(value);

		fj(1, n - 1) {
			fi(1, n - 1) {
				value[j][i] = 1;
				fo(0, 3) {
					if (matr[j + dy[o]][i + dx[o]] == '#') {
						value[j][i] += 4;
					}
				}
			}
		}

		if (!Dijkstra(value, final)) {
			Exit();
		}
		
		Read();
	}
}

void Strategy8() {
	int i, j;
	int flag = 0;
	bool final[MAX][MAX];
	
	while (1) {

		ZERO(final);

		if (x <= 6 && !flag) {
			flag = 1;
		}

		if (flag == 0) {
			fi(0, 5) {
				final[40][i] = 1;
			}
		} else if (flag == 1) {
			fi(0, 80) {
				final[80][i] = 1;
			}
		} else {
			fj(0, n) {
				fi(0, n) {
					if (Border(i, j)) {
						final[j][i] = 1;
					}
				}
			}
		}

		if (!bfs(final)) {
			if (flag == 0) {
				flag = 1;
				continue;
			}
			if (flag == 1) {
				flag = 2;
				continue;
			}
			Exit();
		}
		
		Read();
	}
}

void Strategy9() {
	int i;
	int flag = 0;
	bool final[MAX][MAX];
	
	while (1) {

		ZERO(final);

		if (flag == 0) {
			final[40][5] = 1;
			if (!bfs(final)) flag = 1;
		}

		if (flag == 1) {
			final[75][5] = 1;
			if (!bfs(final)) flag = 2;
		}

		if (flag == 2) {
			fi(5, 75) {
				final[i][80] = 1;
			}
			if (!bfs(final)) Exit();
		}
		
		Read();
	}
}

void Init() {
	int i, j;
	fj(0, n) {
		fi(0, n) {
			matr[j][i] = '.';
		}
	}
}

void Sample() {
	Move(0, 1); Read();
	Move(1, 1); Read();
	Move(1, 2); Read();
	while (1) {
		Move(3, 1); Read();
	}
}

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
#ifdef LOG
	flog = fopen("log.txt", "w");
	flog2 = fopen("log2.txt", "w");
#endif

	fscanf(fin, "%d", &num);

	x = n / 2;
	y = n / 2;
	last = 4;

	Init();

	if (num == 0) {
		Sample();
	}

	rotation = (num - 1) % 4;

	switch ((num - 1) / 4 + 1) {
		case 1:
			Strategy1();
			break;
		case 2:
			Strategy2();
			break;
		case 3:
			Strategy3();
			break;
		case 4:
			Strategy4();
			break;
		case 5:
			Strategy5();
			break;
		case 6:
			Strategy6();
			break;
		case 7:
			Strategy7();
			break;
		case 8:
			Strategy8();
			break;
		case 9:
			Strategy9();
			break;
		default:
			Exit();
			break;
	}

	return 0;
}
