#define _CRT_SECURE_NO_DEPRECATE

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

#define MAX 120

int rx, ry;

char com;
int d;

int n = 80;

char matr[MAX][MAX];
int color[MAX][MAX];

vector <pair<int, int> > v;

int dx[] = {-1,0,1,0,-1,-1,1,1};
int dy[] = {0,-1,0,1,-1,1,-1,1};

void Init() {
	int i, j;
	fi(0, n / 2) {
		color[n / 2 - i][i] = 1;
		color[n / 2 + i][i] = 1;
		v.pb(mp(n / 2 - i, i));
		v.pb(mp(n / 2 + i, i));
	}
	fi(n / 2, n) {
		color[-n / 2 + i][i] = 1;
		color[n + n / 2 - i][i] = 1;
		v.pb(mp(-n / 2 + i, i));
		v.pb(mp(n + n / 2 - i, i));
	}
	fj(0, n) {
		fi(0, n) {
			matr[j][i] = '.';
		}
	}
}

int last;

int Dist(int x1, int y1, int x2, int y2) {
	return abs(x2 - x1) + abs(y2 - y1);
}

bool Field(int x, int y) {
	if (x < 0 || x > n) return false;
	if (y < 0 || y > n) return false;
	return true;
}

bool Neighbour(int x, int y) {
	int x2, y2;
	int i;
	fi(0, 7) {
		x2 = x + dx[i];
		y2 = y + dy[i];
		if (!Field(x2, y2)) continue;
		if (matr[y2][x2] == '#') return true;
	}
	return false;
}

void Burn(int x, int y) {
	int i, j, o;
	int b, bx, by;
	int b2, bx2, by2;
	b = 1000000000;
	bx = 0;
	by = 0;
	b2 = 1000000000;
	bx2 = 0;
	by2 = 0;
	fo(0, SIZE(v) - 1) {
		i = v[o].first;
		j = v[o].second;
		
		if (matr[j][i] != '#' && Dist(i, j, x, y) < b && (Dist(rx, ry, i, j) <= 5 * last / 2 || !Neighbour(i, j))) {
			b = Dist(i, j, x, y);
			bx = i;
			by = j;
		}

		if (matr[j][i] != '#' && Dist(rx, ry, i, j) < b2 && (Dist(rx, ry, i, j) <= 7 || !Neighbour(i, j))) {
			b2 = Dist(rx, ry, i, j);
			bx2 = i;
			by2 = j;
		}
	}

	if (b2 < Dist(rx, ry, bx, by) - last * 10 || b2 < Dist(rx, ry, bx, by) && b2 <= 5) {
		bx = bx2;
		by = by2;
	}

	if (bx == 0 && by == 0) {
		fo(0, SIZE(v) - 1) {
			i = v[o].first;
			j = v[o].second;

			if (matr[j][i] != '#') {
				bx = i;
				by = j;
				break;
			}
		}
	}

	matr[by][bx] = '#';
	printf("%d %d\n", by, bx);
	fflush(stdout);
}

int main() {
	int i, j;
	int f;
	rx = n / 2;
	ry = n / 2;

	Init();

	while (1) {
		scanf(" %c", &com);
		if (com == 'E') break;
		scanf("%d", &d);
		if (com == 'U') ry -= d;
		if (com == 'D') ry += d;
		if (com == 'L') rx -= d;
		if (com == 'R') rx += d;

		last = d;

		f = 0;
		if (com == 'U') {
			fdj(ry, 0) {
				if (color[j][rx]) {
					Burn(rx, j);
					f = 1;
					break;
				}
			}
		}
		if (com == 'D') {
			fj(ry, n) {
				if (color[j][rx]) {
					Burn(rx, j);
					f = 1;
					break;
				}
			}
		}
		if (com == 'L') {
			fdi(rx, 0) {
				if (color[ry][i]) {
					Burn(i, ry);
					f = 1;
					break;
				}
			}
		}
		if (com == 'R') {
			fi(rx, n) {
				if (color[ry][i]) {
					Burn(i, ry);
					f = 1;
					break;
				}
			}
		}
		if (!f) {
			Burn(rx, ry);
		}
	}
	return 0;
}
