#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;

#ifdef LOG

FILE *flog;

#endif

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAXN 110
#define MAXK 10

#define MAX_QUERIES 10000

int n, k;
int a[MAXK];
int x;
int q;

int color[MAXN];
int p;

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	int t;
	int i;
	int f;
	char str[100];
#ifdef LOG
	flog = fopen("log.txt", "w");
#endif
	fscanf(fin, "%d %d", &n, &k);
	fi(1, n) {
		fscanf(fin, "%d", &a[i]);
	}

	ZERO(color);
	x = 1;

	color[x] = 1;
	p = n - 1;

	printf("%d %d\n", n, k);
	fflush(stdout);

#ifdef LOG
	fprintf(flog, "%d %d\n", n, k);
	fflush(flog);
#endif

	while (1) {
		q++;

		switch (scanf("%d", &t)) {
			case 1:
				break;
			case -1:
				id("Unexpected EOF");
				break;
			default:
				pe("Wrong output format");
				break;
		}

		if (t < -k || t == 0 || t > k) {
			//printf("Quit\n");
			//fflush(stdout);
#ifdef LOG
			fprintf(flog, "Quit\n");
			fflush(flog);
#endif
			pe("Wrong elevator number");
		}

		f = 0;
		if (t < 0) {
			if (x - a[-t] >= 1) {
				x -= a[-t];
				f = 1;
			}
		} else {
			if (x + a[t] <= n) {
				x += a[t];
				f = 1;
			}
		}

		if (color[x] == 0) {
			color[x] = 1;
			p--;
			if (p == 0) {
				printf("Quit\n");
				fflush(stdout);
#ifdef LOG
				fprintf(flog, "Quit\n");
				fflush(flog);
#endif
				sprintf(str, "%d queries", q);
				ok(str);
			}
		}

		if (q >= MAX_QUERIES) {
			//printf("Quit\n");
			//fflush(stdout);
#ifdef LOG
			fprintf(flog, "Quit\n");
			fflush(flog);
#endif
			ql("Too many queries");
		}

		if (f) {
			printf("Yes\n");
			fflush(stdout);
#ifdef LOG
			fprintf(flog, "Yes\n");
			fflush(flog);
#endif
		} else {
			printf("No\n");
			fflush(stdout);
#ifdef LOG
			fprintf(flog, "No\n");
			fflush(flog);
#endif
		}

	}

	return 0;
}
