//////////////////////////gen.h//////////////////////////

#include "testlib.h"
#include <iostream>

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

using namespace std;

int gen_test = 0;
bool first;

void Next() {
	gen_test++;
	startTest(gen_test);
	first = true;
}

/*void Skip(int x) {
	gen_test += x;
}*/

void Line() {
	cout << endl;
	first = true;
}

void NumberNS(int a) {
	cout << a;
}

void NumberNS(int64 a) {
    cout << a;
}

void Number(int a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	cout << a;
}

void Number(int a, int b) {
	Number(a); Number(b);
}

void Number(int a, int b, int c) {
	Number(a); Number(b); Number(c);
}

void Number(int a, int b, int c, int d) {
	Number(a); Number(b); Number(c); Number(d);
}

void Number(int64 a) {
	if (!first) {
		cout << " ";
	}
	first = false;
	cout << a;
}

void Number(int64 a, int64 b) {
	Number(a); Number(b);
}

void Number(int64 a, int64 b, int64 c) {
	Number(a); Number(b); Number(c);
}

void Number(int64 a, int64 b, int64 c, int64 d) {
	Number(a); Number(b); Number(c); Number(d);
}

void String(const char *s) {
	cout << string(s);
}

void Char(char c) {
	cout << c;
}

void Space() {
	first = false;
	cout << " ";
}

int Random(int a, int b) {
	return rnd.next(a, b);
}

int64 Random(int64 a, int64 b) {
	return rnd.next(a, b);
}

/////////////////////////////////////////////////////////

#define MAX 110

int n, k;
int a[MAX];
bool color[MAX];
int u[MAX];

void dfs(int x) {
	int i;
	color[x] = 1;
	for (i = 1; i <= k; i++) {
		if (x - a[i] >= 1 && !color[x - a[i]]) {
			dfs(x - a[i]);
		}
		if (x + a[i] <= n && !color[x + a[i]]) {
			dfs(x + a[i]);
		}
	}
}

bool Check() {
	int i;
	ZERO(color);

	dfs(1);

	for (i = 1; i <= n; i++) {
		if (!color[i]) return false;
	}
	return true;
}

void Gen(int a, int b, int c, int d, int e, int f) {
	Next();
	Number(100, 6); Line();
	Number(a, b, c); Number(d, e, f); Line();
}

void GenRandom(int n, int k, int a1, int a2) {
	int t;
	int i;
	Next();
	Number(n, k); Line();
	::n = n;
	::k = k;
	do {
		ZERO(u);
		fi(1, k) {
			do {
				t = Random(min(n - 1, a1), min(n - 1, a2));
			} while (u[t]);
			u[t] = 1;
			a[i] = t;
		}
	} while (!Check());
	fi(1, k) {
		Number(a[i]);
	}
	Line();
}

void GenOneOdd(int n, int k, int x) {
	int i;
	int t;
	Next();
	Number(n, k); Line();
	::n = n;
	::k = k;
	do {
		fi(1, k) {
			if (x == i) {
				do {
					t = Random(2, n - 1);
				} while (t % 2 == 0);
				a[i] = t;
			} else {
				do {
					t = Random(2, n - 1);
				} while (t % 2 != 0);
				a[i] = t;
			}
		}
	} while (!Check());
	fi(1, k) {
		Number(a[i]);
	}
	Line();
}

void Sample() {
	Next();
	Number(6, 2); Line();
	Number(2, 3); Line();
}

int main(int argc, char* argv[]) {
	int i, j;
	registerGen(argc, argv);

	Sample();

	fi(1, 5) {
		GenRandom(Random(5, 15), Random(2, 3), 2, 4);
	}

	Next();
	Number(2, 1); Line();
	Number(1); Line();

	Next();
	Number(10, 1); Line();
	Number(1); Line();

	Next();
	Number(10, 2); Line();
	Number(9, 1); Line();

	fi(1, 5) {
		GenRandom(Random(20, 40), Random(3, 5), 5, 13);
	}

	GenRandom(50, 5, 20, 40);

	fi(1, 5) {
		GenRandom(Random(60, 80), Random(4, 5), 7, 70);
	}

	Next();
	Number(100, 1); Line();
	Number(1); Line();

	Next();
	Number(100, 2); Line();
	Number(99, 1); Line();

	Next();
	Number(100, 2); Line();
	Number(99, 2); Line();

	Next();
	Number(100, 6); Line();
	Number(99, 2, 2); 
	Number(99, 2, 99); 
	Line();

	Gen(91, 67, 87, 83, 49, 93);
	Gen(49, 95, 53, 71, 96, 91);
	Gen(49, 53, 93, 92, 97, 91);
	Gen(80, 83, 49, 94, 78, 67);
	Gen(87, 83, 68, 49, 94, 89);
	Gen(70, 95, 98, 58, 50, 60);
	Gen(98, 58, 91, 72, 48, 94);
	Gen(48, 50, 78, 94, 92, 99);
	Gen(48, 84, 50, 62, 90, 95);
	Gen(86, 70, 52, 99, 72, 50);
	Gen(52, 50, 54, 74, 81, 58);
	Gen(56, 84, 91, 62, 94, 50);
	Gen(61, 81, 99, 98, 95, 50);

	fi(1, 10) {
		GenRandom(100, 6, 2, 99);
	}

	fi(1, 5) {
		GenRandom(100, 6, 20, 99);
	}

	fi(1, 5) {
		GenRandom(100, 6, 45, 99);
	}

	fi(1, 5) {
		GenRandom(100, 6, 48, 99);
	}

	GenRandom(100, 6, 49, 99);

	fj(2, 5) {
		GenRandom(100, j, 20, 99);
		GenRandom(100, j, 30, 99);
		GenRandom(100, j, 40, 99);
	}

	Next();
	Number(100, 6); Line();
	Number(2, 2, 2);
	Number(2, 2, 99);
	Line();

	Next();
	Number(100, 6); Line();
	Number(49, 49, 49);
	Number(49, 49, 50);
	Line();

	Next();
	Number(100, 6); Line();
	Number(50, 50, 50);
	Number(50, 49, 50);
	Line();

	Next();
	Number(100, 6); Line();
	Number(99, 6, 8);
	Number(50, 49, 50);
	Line();

	fi(1, 6) {
		GenOneOdd(100, 6, i);
	}

	return 0;
}
