#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;

#ifdef LOG
FILE *flog, *flog2
#endif

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAX 100
#define MAX_QUERIES 100000

int m, n;

char matr[MAX][MAX];
bool stone[MAX][MAX];

bool s;

int x, y;

int dx[] = {-1,0,1,0};
int dy[] = {0,-1,0,1};

pair <int, int> teleport[MAX][MAX];

int q;

void Print() {
#ifdef LOG
	int i, j;
	fj(1, m) {
		fi(1, n) {
			if (i == x && j == y) {
				fprintf(flog, "@");
			} else if (stone[j][i]) {
				fprintf(flog, "o");
			} else {
				fprintf(flog, "%c", matr[j][i]);
			}
		}
		fprintf(flog, "\n");
	}
	fprintf(flog, "\n");
	fflush(flog);
#endif
}

bool Digit(int x, int y) {
	return matr[y][x] >= '0' && matr[y][x] <= '9';
}

void PrintCell() {
	if (stone[y][x]) {
		printf("CELL WITH STONE\n");
		fflush(stdout);
#ifdef LOG2
		fprintf(flog2, "CELL WITH STONE\n");
		fflush(flog2);
#endif
	} else {
		printf("EMPTY CELL\n");
		fflush(stdout);
#ifdef LOG2
		fprintf(flog2, "EMPTY CELL\n");
		fflush(flog2);
#endif
	}
}

void Move(int dir) {
	int x2, y2;

	x2 = x + dx[dir];
	y2 = y + dy[dir];
	if (matr[y2][x2] == '#') {
		printf("WALL\n");
		fflush(stdout);
#ifdef LOG2
		fprintf(flog2, "WALL\n");
		fflush(flog2);
#endif
		return;
	}

	if (Digit(x2, y2)) {
		x = teleport[y2][x2].first;
		y = teleport[y2][x2].second;
	} else {
		x = x2;
		y = y2;
	}

	PrintCell();

	Print();
}

int out;

pair <int, int> FindPair(int x, int y, char c) {
	int i, j;
	fj(1, m) {
		fi(1, n) {
			if (i == x && j == y) continue;
			if (matr[j][i] == c) return mp(i, j);
		}
	}
	return mp(0, 0);
}

void Init() {
	int i, j;
	pair <int, int> p;
	fj(1, m) {
		fi(1, n) {
			if (Digit(i, j)) {
				p = FindPair(i, j, matr[j][i]);
				teleport[j][i] = p;
				teleport[p.second][p.first] = mp(i, j);
			}
		}
	}
}

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	int i, j;
	int flag;
	int ans;
	char com[50];
	char dir[50];
	char str[50];
#ifdef LOG
	flog = fopen("log.txt", "w");
#endif
#ifdef LOG2
	flog2 = fopen("log2.txt", "w");
#endif
	fscanf(fin, "%d %d", &m, &n);
	fj(1, m) {
		fscanf(fin, "%s", matr[j] + 1);
	}
	flag = 0;
	fj(1, m) {
		fi(1, n) {
			if (matr[j][i] == '@') {
				y = j;
				x = i;
				flag = 1;
				matr[j][i] = '.';
				break;
			}
		}
		if (flag) break;
	}
	Init();
	q = 0;
	s = 1;
	Print();
	while (1) {
		q++;
		switch (scanf("%10s", com)) {
			case 1:
				break;
			case -1:
				id("Unexpected EOF");
				break;
			default:
				pe("Wrong output format");
				break;
		}
		if (strcmp(com, "MOVE") == 0) {
			switch (scanf("%10s", dir)) {
				case 1:
					break;
				case -1:
					id("Unexpected EOF");
					break;
				default:
					pe("Wrong output format");
					break;
			}
#ifdef LOG
			fprintf(flog, "MOVE %s\n\n", dir);
#endif
			if (strcmp(dir, "UP") == 0) {
				Move(1);
			} else if (strcmp(dir, "DOWN") == 0) {
				Move(3);
			} else if (strcmp(dir, "LEFT") == 0) {
				Move(0);
			} else if (strcmp(dir, "RIGHT") == 0) {
				Move(2);
			} else {
				//printf("END\n");
				//fflush(stdout);
				pe("Unknown direction");
			}			
		} else if (strcmp(com, "DROP") == 0) {
#ifdef LOG
			fprintf(flog, "DROP\n\n");
#endif
			if (s) {
				s = 0;
				stone[y][x] = 1;
			}
			PrintCell();
		} else if (strcmp(com, "TAKE") == 0) {
#ifdef LOG
			fprintf(flog, "TAKE\n\n");
#endif
			if (stone[y][x]) {
				stone[y][x] = 0;
				s = 1;
			}
			PrintCell();
		} else if (strcmp(com, "DONE") == 0) {

			switch (scanf("%d", &out)) {
				case 1:
					break;
				case -1:
					id("Unexpected EOF");
					break;
				default:
					pe("Wrong output format");
					break;
			}
			
#ifdef LOG
			fprintf(flog, "DONE %d\n\n", out);
			fflush(flog);
#endif
			ans = 0;
			fj(1, m) {
				fi(1, n) {
					if (matr[j][i] == '.' || matr[j][i] >= '0' && matr[j][i] <= '9') {
						ans++;
					}
				}
			}

			if (out != ans) {
				sprintf(str, "Found: %d. Expected: %d", out, ans);
				wa(str);
			} else {
				sprintf(str, "Answer: %d. Queries: %d", ans, q);
				ok(str);
			}
		} else {
			//printf("END\n");
			//fflush(stdout);
			pe("Unknown command");
		}

		if (q >= MAX_QUERIES) {
			//printf("END\n");
			//fflush(stdout);
			ql("Too much queries");
		}
	}
	return 0;
}
