#define _CRT_SECURE_NO_DEPRECATE

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <memory.h>
#include <string.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fu(a, b) for(u=a; u<=b; u++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

#define MAX 100

#define WALL 0
#define EMPTY 1
#define STONE 2
#define TELEPORT 3

char matr[50][MAX][MAX];
int color[50][MAX][MAX];

pair <int, pair<int, int> > teleport[50][MAX][MAX];

int dx[] = {-1,0,1,0};
int dy[] = {0,-1,0,1};
char *s[] = {"LEFT", "UP", "RIGHT", "DOWN"};

int q;
int Z;

int Move(int dir) {
	char str[100];
	printf("MOVE %s\n", s[dir]);
	fflush(stdout);
	gets(str);
	if (strcmp(str, "EMPTY CELL") == 0) {
		return EMPTY;
	} else if (strcmp(str, "CELL WITH STONE") == 0) {
		return STONE;
	} else if (strcmp(str, "WALL") == 0) {
		return WALL;
	} else {
		exit(0);
	}
}

int MoveBack(int dir) {
	char str[100];
	printf("MOVE %s\n", s[(dir + 2) % 4]);
	fflush(stdout);
	gets(str);
	if (strcmp(str, "EMPTY CELL") == 0) {
		return EMPTY;
	} else if (strcmp(str, "CELL WITH STONE") == 0) {
		return STONE;
	} else if (strcmp(str, "WALL") == 0) {
		return WALL;
	} else {
		exit(0);
	}
}

void Drop() {
	char str[100];
	printf("DROP\n");
	fflush(stdout);
	gets(str);
	if (strcmp(str, "END") == 0) {
		exit(0);
	}
}

void Take() {
	char str[100];
	printf("TAKE\n");
	fflush(stdout);
	gets(str);
	if (strcmp(str, "END") == 0) {
		exit(0);
	}
}

bool KnownTeleport(char x) {
	return x >= '0' && x <= '9';
}

bool UnknownTeleport(char x) {
	return x == '*';
}

bool Teleport(char x) {
	return x >= '0' && x <= '9' || x == '*';
}

void ForwardAndBack() {
	int i;
	fi(0, 3) {
		if (Move(i) != WALL) {
			MoveBack(i);
			break;
		}
	}
}

int Check(int dir) {
	Drop();
	if (Move(dir) == WALL) {
		Take();
		return WALL;
	}
	switch (MoveBack(dir)) {
		case STONE:
			Take();
			return EMPTY;		
		case EMPTY:
			Move(dir);
			MoveBack(dir);
			Take();
			return TELEPORT;
		case WALL:
			ForwardAndBack();
			MoveBack(dir);
			Take();
			return TELEPORT;
	}
	
	return -1;
}

int color0[MAX][MAX];

void dfs(int x, int y, char matr[MAX][MAX]) {
	int x2, y2;
	int i;
	color0[y][x] = 1;
	fi(0, 3) {
		x2 = x + dx[i];
		y2 = y + dy[i];
		if (color0[y2][x2]) continue;
		if (Teleport(matr[y][x])) {
			if (Move(i) == WALL) {
				matr[y2][x2] = '#';
			} else {				
				matr[y2][x2] = '.';
				dfs(x2, y2, matr);
				MoveBack(i);
				ForwardAndBack();
			}
		} else {
			switch (Check(i)) {
				case WALL:
					matr[y2][x2] = '#';
					break;
				case EMPTY:
					matr[y2][x2] = '.';
					Move(i);
					dfs(x2, y2, matr);
					MoveBack(i);
					break;
				case TELEPORT:
					if (matr[y2][x2] == 0) matr[y2][x2] = '*';
					Move(i);
					ForwardAndBack();
					dfs(x2, y2, matr);
					MoveBack(i);
					break;
			}		
		}
	}
}

int color2[50][MAX][MAX];

bool dfs2(int z, int x, int y, int fz, int fx, int fy) {
	int x2, y2;
	int x3, y3, z3;
	int i, j;
	color2[z][y][x] = 1;
	fi(0, 3) {
		x2 = x + dx[i];
		y2 = y + dy[i];
		if (z == fz && x2 == fx && y2 == fy) {
			Move(i);
			return true;
		}
		if (matr[z][y2][x2] == '.') {
			if (!color2[z][y2][x2]) {
				Move(i);
				if (dfs2(z, x2, y2, fz, fx, fy)) return true;
				MoveBack(i);
				if (Teleport(matr[z][y][x])) {
					ForwardAndBack();
				}
			}
		} else if (Teleport(matr[z][y2][x2])) {
			fj(0, 3) {
				
				z3 = teleport[z][y2][x2].first;
				x3 = teleport[z][y2][x2].second.first;
				y3 = teleport[z][y2][x2].second.second;

				x3 += dx[j];
				y3 += dy[j];

				if (z3 == fz && x3 == fx && y3 == fy) {
					Move(i);
					Move(j);
					return true;
				}

				if (matr[z3][y3][x3] == '.' && !color2[z3][y3][x3]) {

					Move(i);
					
					Move(j);
					if (dfs2(z3, x3, y3, fz, fx, fy)) return true;
					MoveBack(j);
					MoveBack(i);
				}
			}
		}	

		if (Teleport(matr[z][y2][x2])) {
			Move(i);
			ForwardAndBack();
			if (dfs2(z, x2, y2, fz, fx, fy)) return true;
			MoveBack(i);
		}
	}
	return false;
}

void MoveTo(int z, int sx, int sy, int fz, int fx, int fy) {
	ZERO(color2);
	dfs2(z, sx, sy, fz, fx, fy);
}

bool dfs3(int z, int x, int y, int &fz, int &fx, int &fy) {
	int x2, y2;
	int x3, y3, z3;
	int i, j;
	color[z][y][x] = 1;
	fi(0, 3) {
		x2 = x + dx[i];
		y2 = y + dy[i];
		if (matr[z][y2][x2] == '.') {
			if (!color[z][y2][x2]) {
				if (Move(i) == STONE) {
					fz = z;
					fx = x2;
					fy = y2;
					return true;
				}
				if (dfs3(z, x2, y2, fz, fx, fy)) return true;
				MoveBack(i);
				if (Teleport(matr[z][y][x])) {
					ForwardAndBack();
				}
			}
		} else if (KnownTeleport(matr[z][y2][x2])) {
			fj(0, 3) {
				
				z3 = teleport[z][y2][x2].first;
				x3 = teleport[z][y2][x2].second.first;
				y3 = teleport[z][y2][x2].second.second;

				x3 += dx[j];
				y3 += dy[j];

				if (matr[z3][y3][x3] == '.' && !color[z3][y3][x3]) {

					Move(i);

					if (Move(j) == STONE) {
						fz = z3;
						fx = x3;
						fy = y3;
						return true;
					}
					if (dfs3(z3, x3, y3, fz, fx, fy)) return true;
					MoveBack(j);
					MoveBack(i);
				}
			}
		}

		if (Teleport(matr[z][y2][x2]) && !color[z][y2][x2]) {
			Move(i);
			ForwardAndBack();
			if (dfs3(z, x2, y2, fz, fx, fy)) return true;
			MoveBack(i);
		}
	}
	return false;
}

bool FindStone(int z, int x, int y, int dir, int &fz, int &fx, int &fy) {
	ZERO(color);
	return dfs3(z, x, y, fz, fx, fy);
}


void Explore(int z, int x, int y) {
	int i, j, o;
	int fx, fy, fz;
	int flag;
	int lz, lx, ly;
	pair <int, pair <int, int> > p;
	vector <int> v;
	matr[z][y][x] = '.';
	ZERO(color0);
	dfs(x, y, matr[z]);

	fj(0, MAX - 1) {
		fi(0, MAX - 1) {
			if (matr[z][j][i] == '*') {

				MoveTo(z, x, y, z, i, j);
				flag = 0;
				v.clear();

				fo(0, 3) {
					if (Move(o) != WALL) {
						Drop();
						MoveBack(o);
						if (!FindStone(z, i, j, o, fz, fx, fy)) {
							v.pb(o);
							ForwardAndBack();
							Move(o);
							Take();
							MoveBack(o);
							ForwardAndBack();
						} else {
							if (!flag) {
								flag = 1;
								fx += dx[(o + 2) % 4];
								fy += dy[(o + 2) % 4];
								if (matr[z][j][i] == '*') {
									matr[z][j][i] = '0' + q;
									matr[fz][fy][fx] = '0' + q;
									q++;
									teleport[fz][fy][fx] = mp(z, mp(i, j));
									teleport[z][j][i] = mp(fz, mp(fx, fy));
								}
							}

							Take();
							MoveBack(o);
							ForwardAndBack();
						}
					}
				}

				if (!flag) {

					if (teleport[z][j][i].first != 0) {
						lz = teleport[z][j][i].first;
						lx = teleport[z][j][i].second.first;
						ly = teleport[z][j][i].second.second;
					} else {
						Z++;
						lz = Z;
						lx = MAX / 2;
						ly = MAX / 2;
						matr[z][j][i] = '0' + q;
						matr[lz][ly][lx] = '0' + q;
						q++;
						teleport[z][j][i] = mp(lz, mp(lx, ly));
						teleport[lz][ly][lx] = mp(z, mp(i, j));
					}

				} else {
					lz = teleport[z][j][i].first;
					lx = teleport[z][j][i].second.first;
					ly = teleport[z][j][i].second.second;

				}

				fo(0, SIZE(v) - 1) {

					if (matr[lz][ly + dy[v[o]]][lx + dx[v[o]]] == 0) {
						Move(v[o]);
						Explore(lz, lx + dx[v[o]], ly + dy[v[o]]);
						MoveBack(v[o]);
						ForwardAndBack();
					}

				}
				ForwardAndBack();
				MoveTo(z, i, j, z, x, y);

			}
		}
	}

}

int main() {
	int i, j, o;
	int ans;
	Z = 1;
	Explore(1, MAX / 2, MAX / 2);
	ans = 0;
	fo(1, Z) {
		fj(0, MAX - 1) {
			fi(0, MAX - 1) {
				if (matr[o][j][i] == '.' || Teleport(matr[o][j][i])) {
					ans++;
				}
			}
		}
	}
	printf("DONE %d\n", ans);
	fflush(stdout);
	return 0;
}
