#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"
#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;


#define MAX 101

int n, m;

char matr[MAX][MAX];

bool Digit(int x, int y) {
	return matr[y][x] >= '0' && matr[y][x] <= '9';
}

pair <int, int> teleport[MAX][MAX];

pair <int, int> FindPair(int x, int y, char c) {
	int i, j;
	fj(1, m) {
		fi(1, n) {
			if (i == x && j == y) continue;
			if (matr[j][i] == c) return mp(i, j);
		}
	}
	return mp(0, 0);
}

void Init() {
	int i, j;
	pair <int, int> p;
	fj(1, m) {
		fi(1, n) {
			if (Digit(i, j)) {
				p = FindPair(i, j, matr[j][i]);
				teleport[j][i] = p;
				teleport[p.second][p.first] = mp(i, j);
			}
		}
	}
}

bool Field(int x, int y) {
	if (x < 1 || x > n) return false;
	if (y < 1 || y > m) return false;
	return true;
}

int x, y;
int q[256];

int color[MAX][MAX];

int dx[] = {-1,0,1,0};
int dy[] = {0,-1,0,1};

void dfs(int x, int y) {
	int i;
	int x2, y2;
	if (color[y][x]) return;
	color[y][x] = 1;
	if (Digit(x, y)) {
		dfs(teleport[y][x].first, teleport[y][x].second);
	}
	fi(0, 3) {
		x2 = x + dx[i];
		y2 = y + dy[i];		
		ensure(Field(x2, y2));
		if (matr[y2][x2] == '#') continue;
		dfs(x2, y2);
	}
}

int main() {
	int i, j;
	registerValidation();
    
	m = inf.readInt(3, 30);
	inf.readSpace();
	n = inf.readInt(3, 30);
	inf.readEoln();

	fj(1, m) {
		strcpy(matr[j] + 1, inf.readWord().c_str());;
		inf.readEoln();
	}

	x = -1;
	y = -1;

	fj(1, m) {
		fi(1, n) {
			if (matr[j][i] == '@') {
				ensure(x == -1);
				matr[j][i] = '.';
				x = i;
				y = j;
			} else {
				ensure(matr[j][i] == '#' || matr[j][i] == '.' || Digit(i, j));
				if (Digit(i, j)) {
					q[matr[j][i]]++;
				}
			}
		}
	}

	fi('0', '9') {
		ensure(q[i] == 0 || q[i] == 2);
	}

	Init();

	dfs(x, y);

	fj(1, m) {
		fi(1, n) {
			if (matr[j][i] == '.') {
				ensure(color[j][i] == 1);
			}
		}
	}

	inf.readEof();
    
	return 0;
}
