#define _CRT_SECURE_NO_DEPRECATE

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

#define MAX 20

int dim;
int n;

double norm[2 * MAX][MAX];
double p[2 * MAX][MAX];

double e[MAX][MAX];
double len[MAX];

double scal[MAX][MAX];

double x[MAX];
double y[MAX];

double sqr(double x) {
	return x * x;
}

double a[MAX];
double b[MAX];

int k;
double matr[MAX][MAX];

void Swap(int l1, int l2, double v[MAX]) {
	int i;
	fi(1, k) {
		swap(matr[l1][i], matr[l2][i]);
	}
	swap(v[l1], v[l2]);
}

void Gauss(double v[MAX], double res[MAX]) {
	int i, j, o;
	int f;
	double g;
	double bst;
	fi(1, k) {
		f = 0;
		bst = -1;
		fj(i, k) {
			if (fabs(matr[j][i]) > bst) {
				bst = fabs(matr[j][i]);
				f = j;
			}
		}

		Swap(i, f, v);

		fj(1, k) {
			if (j == i) continue;
			g = -matr[j][i] / matr[i][i];
			fo(1, k) {
				matr[j][o] += matr[i][o] * g;
			}
			v[j] += v[i] * g;
		}
	}

	fi(1, k) {
		res[i] = v[i] / matr[i][i];
	}

}

void Extend(double x[MAX], double res[MAX]) {
	int i, j;
	double v[MAX];
	k = dim;
	
	fj(1, k) {
		fi(1, k) {
			matr[j][i] = e[i][j];
		}
	}

	ZERO(v);
	fi(1, k) {
		v[i] = x[i];
	}

	Gauss(v, res);
}

int main() {
    signal (SIGPIPE,SIG_IGN);
	double ans;
	double t;
	double xx, xy, yy;
	int i, j, o;
	scanf("%d", &dim);
	n = 2 * dim;
	fi(1, n) {
		fj(1, dim) {
			scanf("%lf", &norm[i][j]);
		}
		fj(1, dim) {
			scanf("%lf", &p[i][j]);
		}
	}
	fi(1, dim) {
		scanf("%lf", &x[i]);
	}
	fi(1, dim) {
		scanf("%lf", &y[i]);
	}
	fi(1, dim) {
		printf("Reflect %d\n", i);
		fflush(stdout);

		fj(1, dim) {
			scanf("%lf", &e[i][j]);
		}

		printf("Request\n", i);
		fflush(stdout);

		scanf("%lf", &len[i]);

		scal[i][i] = sqr(len[i]);

		printf("Reflect %d\n", i);
		fflush(stdout);

		fj(1, dim) {
			scanf("%*lf");
		}

		printf("Request\n", i);
		fflush(stdout);

		scanf("%*lf");

	}

	fi(1, dim) {
		fj(i + 1, dim) {
			printf("Reflect %d\n", i);
			fflush(stdout);
			
			fo(1, dim) {
				scanf("%*lf");
			}

			printf("Request\n", i);
			fflush(stdout);

			scanf("%*lf");

			printf("Reflect %d\n", i);
			fflush(stdout);
			
			fo(1, dim) {
				scanf("%*lf");
			}

			printf("Reflect %d\n", j);
			fflush(stdout);
			
			fo(1, dim) {
				scanf("%*lf");
			}

			printf("Request\n", i);
			fflush(stdout);

			scanf("%lf", &t);

			scal[i][j] = scal[j][i] = (sqr(len[i]) + sqr(len[j]) - sqr(t)) / 2;

			printf("Reflect %d\n", j);
			fflush(stdout);
			
			fo(1, dim) {
				scanf("%*lf");
			}
		}
	}

	Extend(x, a);
	Extend(y, b);

	xx = 0;
	xy = 0;
	yy = 0;

	fi(1, dim) {
		fj(1, dim) {
			xy += a[i] * b[j] * scal[i][j];
			xx += a[i] * a[j] * scal[i][j];
			yy += b[i] * b[j] * scal[i][j];
		}
	}

	ans = sqrt(xx + yy - 2 * xy);

	char tmp[10];

	printf("Answer %.8lf\n", ans);
	fflush(stdout);

	return 0;
}
