//////////////////////////gen.h//////////////////////////

#include "testlib.h"
#include <iostream>

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

using namespace std;

int gen_test = 0;
bool first;

void Next() {
	gen_test++;
	startTest(gen_test);
	first = true;
}

/*void Skip(int x) {
	gen_test += x;
}*/

void Line() {
	cout << endl;
	first = true;
}

void NumberNS(int a) {
	cout << a;
}

void NumberNS(int64 a) {
    cout << a;
}

void Number(int a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	cout << a;
}

void Number(int a, int b) {
	Number(a); Number(b);
}

void Number(int a, int b, int c) {
	Number(a); Number(b); Number(c);
}

void Number(int a, int b, int c, int d) {
	Number(a); Number(b); Number(c); Number(d);
}

void Number(int64 a) {
	if (!first) {
		cout << " ";
	}
	first = false;
	cout << a;
}

void Number(int64 a, int64 b) {
	Number(a); Number(b);
}

void Number(int64 a, int64 b, int64 c) {
	Number(a); Number(b); Number(c);
}

void Number(int64 a, int64 b, int64 c, int64 d) {
	Number(a); Number(b); Number(c); Number(d);
}

void String(const char *s) {
	cout << string(s);
}

void Char(char c) {
	cout << c;
}

void Space() {
	first = false;
	cout << " ";
}

int Random(int a, int b) {
	return rnd.next(a, b);
}

int64 Random(int64 a, int64 b) {
	return rnd.next(a, b);
}

/////////////////////////////////////////////////////////

#define MAX 40

int norm[MAX][MAX];
int p[MAX][MAX];

double matr[MAX][MAX];

void Swap(int l1, int l2, int k) {
	int i;
	fi(1, k) {
		swap(matr[l1][i], matr[l2][i]);
	}
}

bool LinearlyIndependent(int k) {
	int i, j, o;
	int f;
	double g;
	double bst;
	fi(1, k) {
		f = 0;
		bst = -1;
		fj(i, k) {
			if (fabs(matr[j][i]) > bst) {
				bst = fabs(matr[j][i]);
				f = j;
			}
		}

		if (fabs(bst) < 1e-8) return false;

		Swap(i, f, k);

		fj(1, k) {
			if (j == i) continue;
			g = -matr[j][i] / matr[i][i];
			fo(1, k) {
				matr[j][o] += matr[i][o] * g;
			}
		}
	}

	return true;

}

bool Parallel(int a[MAX], int b[MAX], int k) {
	int i;
	int f;
	double g;
	f = 0;
	fi(1, k) {
		if (b[i] == 0 || a[i] != 0) return false;
		if (b[i] != 0 || a[i] == 0) return false;
		if (b[i] == 0 && a[i] == 0) continue;
		if (!f) {
			g = (double)b[i] / (double)a[i];
			f = 1;
		}
		if (fabs(a[i] * g - b[i]) < 1e-8) return false;
	}
	return true;
}


int Scal(int a[MAX], int b[MAX], int k) {
	int i;
	int res;
	res = 0;
	fi(1, k) {
		res += a[i] * b[i];
	}
	return res;
}

bool Check(int k) {
	int i, j;
	fj(1, k) {
		fi(1, k) {
			matr[j][i] = norm[j][i];
		}
	}
	if (!LinearlyIndependent(k)) return false;
	fj(1, k) {
		fi(1, k) {
			matr[j][i] = norm[j + k][i];
		}
	}
	if (!LinearlyIndependent(k)) return false;
	
	fi(1, 2 * k) {
		fj(i + 1, 2 * k) {
			if (Parallel(norm[i], norm[j], k)) return false;
		}
	}

	fi(1, 2 * k) {
		if (Scal(norm[i], p[i], k) == 0) return false;
	}

	return true;
}

void Gen(int dim, int a1, int a2, int n1, int n2, int p1, int p2, int x1, int x2) {
	int i, j;
	Next();
	Number(dim); Line();
	fj(1, dim) {
		fi(1, dim) {
			Number(Random(a1, a2));
		}
		Line();
	}
	do {
		fj(1, 2 * dim) {
			fi(1, dim) {
				norm[j][i] = Random(n1, n2);
				p[j][i] = Random(p1, p2);
			}
		}
	} while (!Check(dim));

	fj(1, 2 * dim) {
		fi(1, dim) {
			Number(norm[j][i]);
		}
		Line();
		fi(1, dim) {
			Number(p[j][i]);
		}
		Line();
	}

	fi(1, dim) {
		Number(Random(x1, x2));
	}
	Line();

	fi(1, dim) {
		Number(Random(x1, x2));
	}
	Line();
}

void Gen2(int dim, int a1, int a2, int prob, int n1, int n2, int p1, int p2, int x1, int x2) {
	int i, j;
	Next();
	Number(dim); Line();
	fj(1, dim) {
		fi(1, dim) {
			if (Random(0, 99) < prob) {
				Number(Random(a1, a2));
			} else {
				Number(0);				
			}
		}
		Line();
	}
	do {
		fj(1, 2 * dim) {
			fi(1, dim) {
				norm[j][i] = Random(n1, n2);
				p[j][i] = Random(p1, p2);
			}
		}
	} while (!Check(dim));

	fj(1, 2 * dim) {
		fi(1, dim) {
			Number(norm[j][i]);
		}
		Line();
		fi(1, dim) {
			Number(p[j][i]);
		}
		Line();
	}

	fi(1, dim) {
		Number(Random(x1, x2));
	}
	Line();

	fi(1, dim) {
		Number(Random(x1, x2));
	}
	Line();
}

void Gen3(int dim, int a1, int a2, int n1, int n2, int p1, int p2, int x) {
	int i, j;
	Next();
	Number(dim); Line();
	fj(1, dim) {
		fi(1, dim) {
			Number(Random(a1, a2));
		}
		Line();
	}
	do {
		fj(1, 2 * dim) {
			fi(1, dim) {
				norm[j][i] = Random(n1, n2);
				p[j][i] = Random(p1, p2);
			}
		}
	} while (!Check(dim));

	fj(1, 2 * dim) {
		fi(1, dim) {
			Number(norm[j][i]);
		}
		Line();
		fi(1, dim) {
			Number(p[j][i]);
		}
		Line();
	}

	fi(1, dim) {
		Number(-x);
	}
	Line();

	fi(1, dim) {
		Number(x);
	}
	Line();
}


void Sample() {
	Next();
	Number(2); Line();
	Number(2, 0); Line();
	Number(0, 2); Line();

	Number(1, 0); Line();
	Number(2, 0); Line();

	Number(-1, 1); Line();
	Number(0, -1); Line();

	Number(0, 1); Line();
	Number(0, -2); Line();

	Number(1, 1); Line();
	Number(2, 2); Line();

	Number(4, 2); Line();
	Number(10, 4); Line();
}

int main(int argc, char* argv[]) {
	int i, j;
	registerGen(argc, argv);

	Sample();

	fi(1, 10) {
		Gen(2, -10, 10, -10, 10, -20, 20, -30, 30);
	}

	fj(3, 9) {
		fi(1, 4) {
			Gen(j, -10, 10, -8 * j, 8 * j, -30 * j, 30 * j, -30 * j, 30 * j);
		}
	}

	Gen2(10, -10, 10, 70, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 50, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 30, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 20, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 10, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 6, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 5, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 4, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 3, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 2, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 1, -100, 100, -1000, 1000, -10000, 10000);
	Gen2(10, -10, 10, 0, -100, 100, -1000, 1000, -10000, 10000);
	fi(1, 10) {
		Gen(10, -10, 10, -100, 100, -1000, 1000, -10000, 10000);
	}
	Gen(10, 10, 10, -100, 100, -1000, 1000, -10000, 10000);
	Gen(10, -10, -10, -100, 100, -1000, 1000, -10000, 10000);

	Gen3(10, 10, 10, -100, 100, -1000, 1000, 10000);
	Gen3(10, -10, -10, -100, 100, -1000, 1000, 10000);

	fi(1, 3) {
		Gen3(10, -10, 10, -100, 100, -1000, 1000, 10000);
	}
	
	return 0;
}
