//////////////////////////gen.h//////////////////////////

#include "testlib.h"
#include <iostream>

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

using namespace std;

int gen_test = 0;
bool first;

void Next() {
	gen_test++;
	startTest(gen_test);
	first = true;
}

/*void Skip(int x) {
	gen_test += x;
}*/

void Line() {
	cout << endl;
	first = true;
}

void NumberNS(int a) {
	cout << a;
}

void NumberNS(int64 a) {
    cout << a;
}

void Number(int a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	cout << a;
}

void Number(double a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	printf("%.18lf", a);
}

void Number(int a, int b) {
	Number(a); Number(b);
}

void Number(int a, int b, int c) {
	Number(a); Number(b); Number(c);
}

void Number(int a, int b, int c, int d) {
	Number(a); Number(b); Number(c); Number(d);
}

void Number(int64 a) {
	if (!first) {
		cout << " ";
	}
	first = false;
	cout << a;
}

void Number(int64 a, int64 b) {
	Number(a); Number(b);
}

void Number(int64 a, int64 b, int64 c) {
	Number(a); Number(b); Number(c);
}

void Number(int64 a, int64 b, int64 c, int64 d) {
	Number(a); Number(b); Number(c); Number(d);
}

void String(const char *s) {
	cout << string(s);
}

void Char(char c) {
	cout << c;
}

void Space() {
	first = false;
	cout << " ";
}

int Random(int a, int b) {
	return rnd.next(a, b);
}

int64 Random(int64 a, int64 b) {
	return rnd.next(a, b);
}

/////////////////////////////////////////////////////////

double pi = acos(-1.);

void Gen(double phi, double psi) {
	Next();
	Number(phi); Number(psi); Line();
}

void GenRandom() {
	double l, r;
	double phi, psi;
	phi = (Random(0, 1000000000) / 1000000000.) * 2 * pi;

	l = pi / 4 + 1e-6;
	r = pi / 2 - 1e-6;

	psi = (Random(0, 1000000000) / 1000000000.) * (r - l) + l;

	Gen(phi, psi);
}

void Sample() {
	Gen(pi, pi / 4);
}

int main(int argc, char* argv[]) {
	int i;
	registerGen(argc, argv);

	Sample();
	fi(1, 4) {
		GenRandom();
	}

	fi(0, 7) {
		Gen(i * pi / 4, pi / 4);
	}

	fi(0, 7) {
		Gen(i * pi / 4, 3 * pi / 8);
	}

	Gen(pi / 2, pi / 2 - 1e-6);
	Gen(pi / 2, pi / 2 - 1e-2);
	Gen(pi / 2, pi / 2 - 5e-1);

	Gen(3 * pi / 2, pi / 2 - 1e-6);
	Gen(3 * pi / 2, pi / 2 - 1e-1);
	Gen(3 * pi / 2, pi / 2 - 5e-1);

	fi(1, 10) {
		GenRandom();
	}

	Gen(3.141380810, 1.431687470);
	Gen(3.104871507, 1.371705368);
	Gen(2.327655716, 1.140715793);
	Gen(1.181726928, 1.190344112);

	return 0;
}
