#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;

#ifdef LOG

FILE *flog, *flog2;

#endif

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAX_QUERIES 10000

#define MAX 150

int n, s;

char str[MAX];
int cur;

void Print() {
	int i;
	fi(0, 4) {
		printf("%c", str[(cur + i) % n]);
	}
	printf("\n");
	fflush(stdout);

#ifdef LOG

	fi(0, 4) {
		fprintf(flog2, "%c", str[(cur + i) % n]);
	}
	fprintf(flog2, "\n");
	fflush(flog2);

	fi(0, n - 1) {
		fprintf(flog, "%c", str[i]);
	}
	fprintf(flog, "\n");
	fi(0, n - 1) {
		if (i == cur || i == (cur + 4) % n) {
			fprintf(flog, "^");
		} else {
			fprintf(flog, " ");
		}
	}
	fprintf(flog, "\n\n");
	fflush(flog);
#endif
}

void Exit() {
	printf("EEEEE\n");	
	fflush(stdout);
#ifdef LOG
	fprintf(flog2, "EEEEE\n");	
	fflush(flog2);
#endif
}

int q;
int sq;

int out;

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	int i;
	int a, b;
	int ans;
	char com[100];
	char g[100];
#ifdef LOG
	flog = fopen("log.txt", "w");
	flog2 = fopen("log2.txt", "w");
#endif
	fscanf(fin, "%d %d", &n, &s);
	fscanf(fin, "%s", str);

	cur = 0;
	q = 0;
	sq = 0;

	Print();

	while (1) {
		switch (scanf("%20s", com)) {
			case 1:
				break;
			case -1:
				id("Unexpected EOF");
				break;
			default:
				pe("Wrong output format");
				break;
		}
		if (strcmp(com, "Next") == 0) {
			q++;
			if (q > MAX_QUERIES) {
				//Exit();
				wa("Too many \"Next\"");
			}
			cur = (cur + s) % n;
			Print();
			sq = 0;
		} else if (strcmp(com, "Swap") == 0) {
			switch (scanf("%d %d", &a, &b)) {
				case 2:
					break;
				case -1:
					id("Unexpected EOF");
					break;
				default:
					pe("Wrong output format");
					break;
			}
			if (a < 1 || a > 5 || b < 1 || b > 5) {
				//Exit();
				pe("Ball number is out of range");
			}
			sq++;
			if (sq > 10) {
				//Exit();
				wa("Too many swaps");
			}
#ifdef LOG
			fprintf(flog, "Swap %d %d\n", a, b);
#endif
			swap(str[(n + cur + a - 1) % n], str[(n + cur + b - 1) % n]);

			Print();
			
		} else if (strcmp(com, "Answer") == 0) {
			switch (scanf("%d", &out)) {
				case 1:
					break;
				case -1:
					id("Unexpected EOF");
					break;
				default:
					pe("Wrong output format");
					break;
			}
			ans = 0;
			fi(0, n - 1) {
				if (str[i] == 'B') {
					ans++;
				}
			}
			if (out != ans) {
				sprintf(g, "Found: %d. Expected: %d", out, ans);
				wa(g);
			}
			sprintf(g, "Answer: %d. Queries: %d", ans, q);
			ok(g);
		} else {
			pe("Unknown command");
		}
	}
	return 0;
}
