//////////////////////////gen.h//////////////////////////

#include "testlib.h"
#include <iostream>

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

using namespace std;

int gen_test = 0;
bool first;

void Next() {
	gen_test++;
	startTest(gen_test);
	first = true;
}

/*void Skip(int x) {
	gen_test += x;
}*/

void Line() {
	cout << endl;
	first = true;
}

void NumberNS(int a) {
	cout << a;
}

void NumberNS(int64 a) {
    cout << a;
}

void Number(int a) {
    if (!first) {
        cout << " ";
    }
    first = false;
	cout << a;
}

void Number(int a, int b) {
	Number(a); Number(b);
}

void Number(int a, int b, int c) {
	Number(a); Number(b); Number(c);
}

void Number(int a, int b, int c, int d) {
	Number(a); Number(b); Number(c); Number(d);
}

void Number(int64 a) {
	if (!first) {
		cout << " ";
	}
	first = false;
	cout << a;
}

void Number(int64 a, int64 b) {
	Number(a); Number(b);
}

void Number(int64 a, int64 b, int64 c) {
	Number(a); Number(b); Number(c);
}

void Number(int64 a, int64 b, int64 c, int64 d) {
	Number(a); Number(b); Number(c); Number(d);
}

void String(const char *s) {
	cout << string(s);
}

void Char(char c) {
	cout << c;
}

void Space() {
	first = false;
	cout << " ";
}

int Random(int a, int b) {
	return rnd.next(a, b);
}

int64 Random(int64 a, int64 b) {
	return rnd.next(a, b);
}

/////////////////////////////////////////////////////////

int n, s;

char str[200];

void New() {
	int i;
	fi(1, 100) {
		str[i] = 'W';
	}
}

void Print() {
	int i;
	Next();
	Number(n, s); Line();
	fi(1, n) {
		Char(str[i]);
	}
	Line();
}

void Put(int x, int n) {
	int i, j;
	int f;
	if (str[x] == 'B') return;
	str[x] = 'B';
	fi(x - 6, x + 6) {
		f = 0;
		fj(0, 4) {
			if (str[(n + i + j) % n] == 'W') {
				f = 1;
				break;
			}
		}
		if (!f) {
			str[x] = 'W';
			return;
		}
	}
}

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

bool Check() {
	return gcd(n, s) <= 5;
}

void GenRandom(int n1, int n2, int s1, int s2, int P) {
	int i;
	do {
		n = Random(n1, n2);
		s = Random(s1, s2);
	} while (!Check());
	New();
	fi(1, n) {
		if (Random(0, 99) < P) Put(i, n);
	}
	Print();
}

void GenRandomGCD(int n1, int n2, int s1, int s2, int P, int g) {
	int i;
	do {
		n = Random(n1, n2);
		s = Random(s1, s2);
	} while (gcd(n, s) != g);
	New();
	fi(1, n) {
		if (Random(0, 99) < P) Put(i, n);
	}
	Print();
}


void GenRandomPeriod(int n1, int n2, int s1, int s2, int p, int P) {
	int i, j;
	int q;
	do {
		n = Random(n1, n2) * p;
		s = Random(s1, s2);
	} while (!Check());
	n /= p;
	New();
	fi(1, n) {
		if (Random(0, 99) < P) {
			if (i == n) {
				q = 0;
				fj(1, n) {
					if (str[i] == 'W') break;
					q++;
				}
				fdj(n, 1) {
					if (str[i] == 'W') break;
					q++;
				}
				if (q >= 4) continue;
			}
			fj(0, p - 1) {
				Put(i + n * j, n * p);
			}
		}
	}

	n *= p;

	Print();
}

void GenRandomPeriodGCD(int n1, int n2, int s1, int s2, int p, int P, int g) {
	int i, j;
	int q;
	do {
		n = Random(n1, n2) * p;
		s = Random(s1, s2);
	} while (gcd(n, s) != g);
	n /= p;
	New();
	fi(1, n) {
		if (Random(0, 99) < P) {
			if (i == n) {
				q = 0;
				fj(1, n) {
					if (str[i] == 'W') break;
					q++;
				}
				fdj(n, 1) {
					if (str[i] == 'W') break;
					q++;
				}
				if (q >= 4) continue;
			}
			fj(0, p - 1) {
				Put(i + n * j, n * p);
			}
		}
	}

	n *= p;

	Print();
}

void GenOne(int n, int s, int x) {
	New();
	::n = n;
	::s = s;
	Put(x, n);
	Print();
}

void GenOnePeriod(int n, int s, int x, int p) {
	int i;
	New();
	::n = n;
	::s = s;
	fi(0, p - 1) {
		Put(x + n * i, n * p);
	}
	::n *= p;
	Print();
}

void Sample() {
	Next();
	Number(21, 5); Line();
	String("BWWWWWBWWWWWBWWWWWBWW"); Line();
}

void GenEmpty() {
	New();
	n = 20;
	s = 1;
	Print();
}

void Special() {
	New();
	n = 100;
	s = 5;
	strcpy(str + 1, "BBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBW");
	Print();

	New();
	n = 100;
	s = 5;
	strcpy(str + 1, "WBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBB");
	Print();

	New();
	n = 100;
	s = 57;
	strcpy(str + 1, "WBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBB");
	Print();

	New();
	n = 100;
	s = 86;
	strcpy(str + 1, "WBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBB");
	Print();

	New();
	n = 100;
	s = 44;
	strcpy(str + 1, "WBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBBWBBBB");
	Print();

	New();
	n = 100;
	s = 44;
	strcpy(str + 1, "WBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWB");
	Print();

	New();
	n = 100;
	s = 1;
	strcpy(str + 1, "WBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWB");
	Print();

	New();
	n = 100;
	s = 31;
	strcpy(str + 1, "WBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWB");
	Print();

	New();
	n = 100;
	s = 66;
	strcpy(str + 1, "WBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWBWB");
	Print();

	New();
	n = 100;
	s = 11;
	strcpy(str + 1, "BWWWWWWWWWWWBWWWWWWWWWWWBWWWWWWWWWWWBWWWWWWWWWWWBWWWWWWWWWBWWWWWWWWWBWWWWWWWWWBWWWWWWWWWBWWWWWWWWWWW");	
	Print();
}

int main(int argc, char* argv[]) {
	int i, j, o;
	registerGen(argc, argv);

	Sample();

	fi(1, 5) {
		GenRandom(20, 30, i, i, Random(20, 40));
	}

	GenEmpty();

	fj(1, 5) {
		fi(1, 3) {
			GenRandomGCD(30, 60, 1, 20, Random(15, 30), j);
		}
	}

	fj(2, 4) {
		fi(1, 4) {
			GenRandomPeriod(max(20, 60 / j), max(20, 80 / j), 1, 100000, j, Random(5, 30));
		}
	}

	fi(1, 6) {
		GenRandom(100, 100, 1, 100, Random(5, 80));
	}

	fi(1, 5) {
		GenRandomGCD(99, 100, 70, 100, 100, i);
	}

	GenOne(100, 57, 4);
	GenOne(100, 21, 98);
	GenOne(100, 99, 53);

	GenOne(20, 99, 14);
	GenOne(30, 37, 30);
	GenOne(40, 84, 2);
	GenOne(50, 47, 45);
	GenOne(60, 97, 57);

	GenOnePeriod(20, 37, Random(1, 20), 5);
	GenOnePeriod(25, 74, Random(1, 25), 4);
	GenOnePeriod(33, 85, Random(1, 33), 3);
	GenOnePeriod(50, 57, Random(1, 50), 2);
	
	fi(1, 5) {
		fj(2, 4) {
			fo(1, 2) {
				GenRandomPeriodGCD(86 / j, 100 / j, 1, 100000, j, Random(20, 80), i);
			}
		}
	}

	fi(1, 5) {
		GenRandom(100, 100, 1, 100, Random(70, 95));
	}

	Special();

	/*fi(1, 500) {
		GenRandom(20, 100, 1, 100, Random(0, 100));
	}*/
	return 0;
}
