#define _CRT_SECURE_NO_DEPRECATE

#include "testlib.h"

#include <string>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <memory.h>
#include <string.h>
#include <signal.h>

using namespace std;

#define pb push_back
#define pf push_front
#define mp make_pair
#define fi(a, b) for(i=a; i<=b; i++)
#define fj(a, b) for(j=a; j<=b; j++)
#define fo(a, b) for(o=a; o<=b; o++)
#define fdi(a, b) for(i=a; i>=b; i--)
#define fdj(a, b) for(j=a; j>=b; j--)
#define fdo(a, b) for(o=a; o>=b; o--)
#define ZERO(x) memset(x, 0, sizeof(x));
#define COPY(x, y) memcpy(x, y, sizeof(y));
#define SIZE(x) (int)x.size()
#define LEN(x) (int)x.length()

typedef long long int64;

FILE *fin;

#ifdef LOG

FILE *flog, *flog2;

#endif

void finish(int code, const string &s) {
	fprintf(stderr, "%s\n", s.c_str());
	fclose(stderr);
	exit(code);
}

void ok(const string &s) {
	finish(0, s);
}

void wa(const string &s) {
	finish(1, s);
}

void pe(const string &s) {
	finish(2, s);
}

void ql(const string &s) {
	finish(3, s);
}

void ir(const string &s) {
	finish(4, s);
}

void id(const string &s) {
	finish(5, s);
}

#ifdef LOG

void Log(string s) {
	fprintf(flog, "%s\n", s.c_str());
	fflush(flog);
}

#endif

#define MAX 110
#define MAX_QUERIES 18

int n;

char a[MAX];
char b[MAX];

int q;

int main() {
	fin = fopen(getenv("JUDGE_TEST_IN"), "r");
	int i;
	int cnt;
	char str[100];
#ifdef LOG
	flog = fopen("log.txt", "w");
	flog2 = fopen("log2.txt", "w");
#endif

	n = 18;

	fscanf(fin, "%s", a + 1);

#ifdef LOG
	fprintf(flog, "%s\n\n", a + 1);
	fflush(flog);
#endif

	while (1) {
		switch (scanf("%20s", b + 1)) {
			case 1:
				break;
			case -1:
				id("Unexpected EOF");
				break;
			default:
				pe("Wrong output format");
				break;
		}
		cnt = 0;
		q++;

		if (strlen(b + 1) != 18) {
			//printf("-1\n");
			//fflush(stdout);
			pe("Wrong length of the string");
		}

		fi(1, n) {
			if (b[i] < 'a' || b[i] > 'd') {
#ifdef LOG
				fprintf(flog, "%s (%d)\n", b + 1, cnt);
				fprintf(flog2, "-1\n");
				fflush(flog2);
#endif
				//printf("-1\n");
				//fflush(stdout);
				pe("Found unexpected character");
			}
			if (a[i] == b[i]) {
				cnt++;
			}
		}

		if (cnt == n) {
			printf("-1\n");
			fflush(stdout);
#ifdef LOG
			fprintf(flog, "%s (%d)\n", b + 1, cnt);
			fprintf(flog2, "-1\n");
			fflush(flog2);
#endif
			sprintf(str, "%d queiries", q);
			ok(str);
		}

		if (q >= MAX_QUERIES) {
#ifdef LOG
			fprintf(flog2, "-1\n");
			fflush(flog2);
#endif
			//printf("-1\n");
			//fflush(stdout);
			ql("Too many queries");
		}

		printf("%d\n", cnt);
		fflush(stdout);

#ifdef LOG
		fprintf(flog2, "%d\n", cnt);
		fprintf(flog, "%s (%d)\n", b + 1, cnt);
		fflush(flog);
		fflush(flog2);
#endif
	}

	return 0;
}
